  
#ifndef _functional_cmpt_h_
#define _functional_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/scimath/functional_forward.h>

using namespace std;

namespace casac {
           


   class  functional  {
       public :


         ~functional();
         functional();

         variant* f( const variant & x = variant());

         int ndim();

         bool done();

         
                                      casac::functional* gaussian1d(
			  double amplitude=1, 
			  double center=0, 
			  double fwhm=1);

         
                                      casac::functional* gaussian2d(
			  double amplitude=1,  const std::vector<double>& center=initialize_vector(1, (double)-1),  const std::vector<double>& fwhm=initialize_vector(1, (double)-1),  const variant & pa = variant());

         
                                      casac::functional* polynomial( const std::vector<double>& coefficients=initialize_vector(1, (double)0));

         
                                      casac::functional* powerlogpoly( const std::vector<double>& coefficients=initialize_vector(1, (double)0));


      private :
#include <tools/scimath/functional_private.h>
   }; 

 
}
#endif
